---
apiVersion: apps/v1
kind: StatefulSet
metadata:
  name: dind
spec:
  serviceName: dind
  replicas: {{ k8s_dind_replicas }}
  selector:
    matchLabels:
      app: dind
  template:
    metadata:
      labels:
        app: dind
    spec:
      containers:
        - name: dind
          image: {{ k8s_dind_version }}
          command:
            - dockerd
          args:
            - "-H"
            - "tcp://0.0.0.0:2375"
            - --tls=false
          env:
            - name: DOCKER_TLS_CERTDIR
              value: ""
          securityContext:
            privileged: true
          ports:
            - containerPort: 2375
          volumeMounts:
            - name: dind-storage
              mountPath: /var/lib/docker
          resources:
            limits:
{% if k8s_dind_cpu_limit %}
              cpu: {{ k8s_dind_cpu_limit }}
{% endif %}
{% if k8s_dind_memory_limit %}
              memory: {{ k8s_dind_memory_limit }}
{% endif %}
            requests:
{% if k8s_dind_cpu_requests %}
              cpu: {{ k8s_dind_cpu_requests }}
{% endif %}
{% if k8s_dind_memory_requests %}
              memory: {{ k8s_dind_memory_requests }}
{% endif %}
  volumeClaimTemplates:
    - metadata:
        name: dind-storage
      spec:
        accessModes:
          - ReadWriteOnce
        storageClassName: {{ k8s_dind_storage_class }}
        resources:
          requests:
            storage: {{ k8s_dind_storage_size }}
---
apiVersion: v1
kind: Service
metadata:
  name: dind
spec:
  selector:
    app: dind
  ports:
    - name: docker
      port: 2375
      targetPort: 2375
  sessionAffinity: ClientIP